#! /bin/jsh
#
# Copyright 2013-2014 Yuichiro Moriguchi
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#
cat << EOF

static int ${2}__step(struct ${4}_tag *__this__, int __c__) {
	switch(__this__->state) {
EOF
print_states $1 $6
cat << EOF
	}
	return 0;
}

static int ${2}__accepted(struct ${4}_tag *__this__) {
EOF
print_accepts $1
cat << EOF
}

static ${3}${2}__gettoken(struct ${4}_tag *__this__, char *__b__) {
	switch(__this__->state) {
EOF
print_token $1
cat << EOF
	default:  return $5;
	}
}

static int ${2}__isdead(struct ${4}_tag *__this__) {
EOF
print_nfadead $1
echo '}'
